precision highp float;
precision highp int;

uniform sampler2D regionsTexture;
varying vec2 v_texcoord;

uniform vec4 selectedColor;
uniform int selectedRegion;

int round(float rInput) {
    float fInput = floor(rInput);
    float cInput = ceil(rInput);
    if (abs(fInput - rInput) > abs(cInput - rInput)) {
        return int(fInput);
    } else {
        return int(cInput);
    }
}

void main()
{
    vec4 regionColor = texture2D(regionsTexture, v_texcoord);

    vec4 bytes = regionColor * 255.0;

    int regionIndex = round(bytes.r) * 65536 + round(bytes.g) * 256 + round(bytes.b);

    if (regionIndex == selectedRegion) {
        gl_FragColor = selectedColor;
    } else {
        gl_FragColor = vec4(0.0, 0.0, 0.0, 0.0);
    }
}